package fishrungames.bashgid;

import java.util.ArrayList;

import fishrungames.networkutils.ImageManager;


import fishrungames.bashgid.core.ArticleManager.ArticleRecordData;
import fishrungames.bashgid.core.ArticleManager.ArticleShortData;
import fishrungames.bashgid.core.DatabaseGetJournalTask;
import fishrungames.bashgid.core.JournalManager;
import fishrungames.bashgid.core.NewsManager;
import fishrungames.bashgid.core.JournalManager.JournalSemiFullData;
import fishrungames.bashgid.core.NewsManager.NewsRecord;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;

import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import it.sephiroth.android.library.widget.HListView;

public class MainPageFragment extends Fragment {
	
	
	String [] teaserHeaderArray = { "Разное"};
	
	int[] varietyContentIdArray = { 1, 2, 3, 4 };

	
	ListView listView;
	ListAdapter listAdapter;
	View header;
	ProgressBar progressBar;
	
	JournalSemiFullData newsJournal;

	@SuppressLint("InflateParams")
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.fragment_main_page, container, false);
			
		listView = (ListView) rootView.findViewById(R.id.listView);
		
		listAdapter = new ListAdapter(getActivity());
		
		
		header = inflater.inflate(R.layout.main_page_header, null);
			
		RestoreJournal();
		MainActivity.getInstance().StartDownloadNewsTask();
		
		listView.addHeaderView(header);
		
		listView.setAdapter(listAdapter);
		
		progressBar = (ProgressBar)header.findViewById(R.id.progressBar);
		
		progressBar.setVisibility(View.VISIBLE);
		
		Button moreNewsButton = (Button) header.findViewById(R.id.moreNewsButton);
		
		moreNewsButton.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				MainActivity.getInstance().OpenNewsScreen();
			}
		}
		);
		
		Button searchButton = (Button) header.findViewById(R.id.searchButton);
		
		searchButton.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				MainActivity.getInstance().OpenSearchScreen();
			}
		}
		);
			
		return rootView;
	}


	void RestoreJournal()
	{
		newsJournal = JournalManager.CreateEmptyJournal();
		
		RefreshJournal();
	}
	
	void RefreshJournal()
	{
		DatabaseGetJournalTask task = new DatabaseGetJournalTask();

		task.mHandler = MainActivity.getInstance().mHandler;

		Bundle bundle = new Bundle();
		
		bundle.putString("journalName", "news");
		
		bundle.putInt("count", 3);

		task.execute(bundle);
	}
	
	public void SetJournal(JournalSemiFullData journal)
	{
		//Xperimental
		if (journal != null)
		{
		progressBar.setVisibility(View.GONE);
		
		newsJournal = journal;
		
		ImageButton news1ImageButton = (ImageButton) header.findViewById(R.id.news1ImageButton);
		ImageButton news2ImageButton = (ImageButton) header.findViewById(R.id.news2ImageButton);
		ImageButton news3ImageButton = (ImageButton) header.findViewById(R.id.news3ImageButton);
		
		Button news1Button = (Button)header.findViewById(R.id.news1Button);
		Button news2Button = (Button)header.findViewById(R.id.news2Button);
		Button news3Button = (Button)header.findViewById(R.id.news3Button);
		
		if (newsJournal.articleArr.size() > 0)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news1ImageButton, newsJournal.articleArr.get(0).previewImageUrl);
			news1Button.setText(newsJournal.articleArr.get(0).title);
			
			news1ImageButton.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(0).name));
			news1Button.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(0).name));
		}
		else
		{
			news1ImageButton.setImageResource(R.drawable.transparent);
			news1Button.setText(R.string.news_record_not_available);
			news1ImageButton.setOnClickListener(null);
			news1Button.setOnClickListener(null);
		}
		
		if (newsJournal.articleArr.size() > 1)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news2ImageButton, newsJournal.articleArr.get(1).previewImageUrl);
			news2Button.setText(newsJournal.articleArr.get(1).title);
			news2ImageButton.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(1).name));
			news2Button.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(1).name));
		}
		else
		{
			news2ImageButton.setImageResource(R.drawable.transparent);
			news2Button.setText(R.string.news_record_not_available);
			news2ImageButton.setOnClickListener(null);
			news2Button.setOnClickListener(null);
		}
		
		if (newsJournal.articleArr.size() > 2)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news3ImageButton, newsJournal.articleArr.get(2).previewImageUrl);
			news3Button.setText(newsJournal.articleArr.get(2).title);
			news3ImageButton.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(2).name));
			news3Button.setOnClickListener(new NewsButtonOnClickListener(newsJournal.articleArr.get(2).name));
		}
		else
		{
			news3ImageButton.setImageResource(R.drawable.transparent);
			news3Button.setText(R.string.news_record_not_available);
			news3ImageButton.setOnClickListener(null);
			news3Button.setOnClickListener(null);
		}
	
		
		
		listAdapter.notifyDataSetChanged();
		
		}
		
	}
	
	
	public class ListAdapter extends BaseAdapter {
	    private Context mContext;

	    public ListAdapter(Context c) {
	        mContext = c;
	    }

	    public int getCount() {
	        return teaserHeaderArray.length;
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	View view;
	    	
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.main_page_list_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView textView = (TextView) view.findViewById(R.id.dateTextView);
	        
	        Button button = (Button) view.findViewById(R.id.button);
	        
	        HListView hListView = (HListView) view.findViewById(R.id.hListView);
	        
	        hListView.setAdapter(new MainPageHListViewAdapters.SimpleElementAdapter(getActivity()));

	        textView.setText(teaserHeaderArray[position]);
	        
	        button.setText(R.string.see_all);

	        return view;
	    }

	}
	
	
	public static class NewsButtonOnClickListener implements OnClickListener
	{
		
		String articleName;
		
		public NewsButtonOnClickListener(String articleName)
		{
			this.articleName = articleName;
		}

		@Override
		public void onClick(View v)
		{
			MainActivity.getInstance().OpenNewsRecordScreen(articleName, MainActivity.TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT);
		}
		
	}
		
}
